//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2021 - Stephane MOTTELET
//
// This file is hereby licensed under the terms of the GNU GPL v3.0,
// For more information, see the COPYING file which you should have received
//
//--------------------------------------------------------------------------

#ifndef _CVODEBRIDGE_HXX_
#define _CVODEBRIDGE_HXX_

int CVODEFun(realtype t, N_Vector y, N_Vector ydot, void *pManager);
int CVODEJac(long int N, realtype t, N_Vector y, N_Vector fy, DlsMat J, void *user_data, N_Vector tmp1, N_Vector tmp2, N_Vector tmp3);
int CVODEEvent(realtype t, N_Vector y, realtype *gout, void *pManager);
void CVODEErrHandler(int error_code, const char *module, const char *function, char *msg, void *pManager);
int CVODEIntCb(realtype t, N_Vector N_VectorY, wchar_t *pwstFlag, void *pManager);

typedef void (*CVODEDynFun)(int *n, double *t, double *y, double *ydot);
typedef void (*CVODEDynFunWithPar)(int *n, double *t, double *y, double *ydot, double *pdblPar);
typedef void (*CVODEDynJac)(int *n, double *t, double *y, double *fy, double *J);
typedef void (*CVODEDynJacWithPar)(int *n, double *t, double *y, double *fy, double *J, double *pdblPar);
typedef int (*CVODEDynIntCb)(int *n, double *t, double *y, int *);
typedef int (*CVODEDynIntCbWithPar)(int *n, double *t, double *y, int*, double *pdblPar);
typedef void (*CVODEDynEvent)(int *n, double *t, double *y, int *ng, double *, int *dir, int *term);
typedef void (*CVODEDynEventWithPar)(int *n, double *t, double *y, int *ng, double *, int *dir, int *term, double *);

#endif
